\chapter{Game Theory or How you can always win}
\label{ch:Game Theory}
Game theory is a mathematical branch interested in studying strategies in games. In particular it is devoted to find the strategy or the best decision-making algorithms that help you achieve the most.\\
Because it deals with the most abstract rules and ideas it is heavily employed also in non-mathematical areas, such as finance, politics, sports $\ldots$. 

\section{Josephus game}
\label{sec:Josephus game}
It is said that in ancient Rome a slave called \cite{Josephus_Wikipedia} has been caught by romans with other 40 men. Romans liked thrill so they ordered all the slaves in a circle and they decided that a certain number of people are skipped and the next person would executed.
\begin{figure}[ht!]
\centering
\includegraphics[width=40mm]{ch/game-theory/img/josephus.png}
\caption{Josephus and his 40 companions:one every 3 men would have been executed}
\end{figure}
The question is very simple: what is the only survivor, last man to be executed?\\
Let $n$ be the number of slaves and $m$ the slaves slipped each iteration, then
$$\mathcal{S}(n,m) \approx (\mathcal{S}(n-1,m) + m + 1) \mod n$$
or, if the reader wishes to have the complete formula
$$\mathcal{S}(n,m) =
\begin{cases}
\text{ if } (\mathcal{S}(n-1,m) + m + 1) \equiv 0 \mod n \to p\\
\text{ else } \to (\mathcal{S}(n-1,m) + m + 1) \mod n
\end{cases}$$
For $m=2$ the formula is simpler
$$\mathcal{S}(n,2) = 1 + 2n + 2^{1 + \lfloor \log n \rfloor}$$
Yet, for $m>2$ there are no \hyperref[sec:A note on notations (cit.)]{closed-form} solutions.

\section{Craps}
\label{sec:Craps}
In a dice game craps, Alex rolls a pair of fair dice in which
\begin{itemize}
\item if he gets 7 on the first roll, he wins immediately
\item else, he keeps rolling the dice until he gets that number again (he wins) or he gets a $7$ (he loses).
\end{itemize}
 What is the probability that
\begin{enumerate}
\item Alex will win this game?
\item Alex's final roll will be 7?
\end{enumerate}
\begin{solution}
The probability for a 7 is $\frac{1}{6}$, the probability for $x\neq 7$ varies from $\frac{1}{36}$ to $\frac{5}{36}$. For example, when trying to get 8 (probability $\frac{5}{36}$), the probability of succeeding before getting a 7 is $\frac{5}{5+6}$ as the 36-5-6 rolls giving neither 7 not 8 can be ignored. The probability of first rolling 8 and then winning is therefore $\frac{5}{36} \cdot \frac{5}{5+6}$. By adding, the total probability of winning is
$$
\begin{aligned}
&\frac1{36}\cdot \frac{1}{1+6}+\frac2{36}\cdot \frac{2}{2+6}+\frac3{36}\cdot \frac{3}{3+6}+\frac4{36}\cdot \frac{4}{4+6}+\frac5{36}\cdot \frac{5}{5+6}+\frac6{36}+\\
&\frac5{36}\cdot \frac{5}{5+6}+\frac4{36}\cdot \frac{4}{4+6}+\frac3{36}\cdot \frac{3}{3+6}+\frac2{36}\cdot \frac{2}{2+6}+\frac1{36}\cdot \frac{1}{1+6} = \frac{6557}{13860}
\end{aligned}
$$
The probability that the game end by rolling a 7, is
$$1- \frac{6557}{13860}+\frac16=\frac{9613}{13860}$$
\end{solution}

\section{Hackenbush}
\label{sec:Hackenbush}
Mathematics isn't all about theorems, definitions and constants! Mathematicians like to play too! Besides, they usually have a great sense of imagination and can invent any game in the world. One of them is Hackenbush: a 2-player game to play in a grid with some segments of different colors: on his turn, a player removes any line segment of his choice. Every line segment no longer connected to the ground by any path is erased and the first player who is unable to move loses.
\begin{figure}[ht!]
\centering
\includegraphics[width=50mm]{ch/game-theory/img/hackenbush.png}
\caption{The simplest version of Hackenbush: \textcolor{red}{RED} VS \textcolor{blue}{BLUE}}
\end{figure}

There are two main variants of the original game:
\begin{itemize}
\item Blue-Red Hackenbush: each line segment is either red or blue and one player is only allowed to cut one kind of segments (\ie{} segments of the same color)
\item Blue-Red-Green Hackenbush: same as \textit{Blue-Red Hackenbush}, but green segments can be deleted by both players
\end{itemize}
If you want to try it out, download \cite{Macintosh_Hackenbush} or \cite{C_Source_Hackenbush}!

\section{Pig}
\label{sec:Pig}
First invented by \cite{John_Scarne_Wikipedia} this game is usually taught to mathematicians during probability classes, because of the important facts about probability calculus they can understand when calculating the probability of a possible game \textit{scenario}.\\
Like all others mathematical games, the rules are very simple and the only tool needed is a die:
\begin{enumerate}
\item if the player rolls a 1, they score nothing and it becomes the next player's turn.
\item if the player rolls any other number, it is added to their turn total and the player's turn continues
\item if a player chooses to \textit{hold}, their turn total is added to their score, and it becomes the next player's turn
\end{enumerate}
and the first one to score $> 100$ wins.\\
The best strategy was computed only recently by Todd W. Neller and visualized by Clifton G. M. Presser in 2001:  at any time, the information needed to perform best and win includes the player's score, the opponent's score, and the turn total; then you would plot these data in a 3D plot and if this point is inside the gray solid, the player should roll, otherwise the player should hold.

\section{Hex}
\label{sec:Hex}
This is another 2-player game that will get you stuck trying to win against your PC: the aim of the \textcolor{red}{RED} player is to link the 2 red borders and vice versa for the \textcolor{blue}{BLUE}. Note that once one player wins, there is no possibility for the other player to connect his sides. Moreover the board boxes are very limited so a match lasts very little time: you should be able to build tournaments with your friends in no time!
\begin{figure}[ht!]
\centering
\includegraphics[width=90mm]{ch/game-theory/img/hex.jpg}
\caption{A typical Hex match \textcolor{red}{RED} VS \textcolor{blue}{BLUE} where \textcolor{blue}{BLUE} has just won}
\end{figure}

\section{Game of Life}
\label{sec:Game of Life}
Every religion has some kind of god, who starts creating stuff at the beginning of everything. But \cite{Watchmaker_Analogy_Wikipedia}? It seems impossible that \textit{something} is created from \textit{anything}! How there can be a universe from nothing (see \cite{A_Universe_From_Nothing} \moreinfo)? \cite{John_Horton_Conway_Wikipedia} helps us figure it out: with just 4 easy rules it can bring to life kites, spaceships, pulsars $\ldots$ and \cite{Much_More}!
\begin{enumerate}
\item Any live cell with fewer than two live neighbors dies, as if caused by under-population
\item Any live cell with two or three live neighbors lives on to the next generation
\item Any live cell with more than three live neighbors dies, as if by overcrowding
\item Any dead cell with exactly three live neighbors becomes a live cell, as if by reproduction
\end{enumerate}

\begin{figure}[ht!]
\centering
\includegraphics[width=90mm]{ch/game-theory/img/gol.png}
\caption{The $90-$th generation of a random start of Conway's Game of Life}
\end{figure}
The readers may be tempted to play with this \textit{game}, yet they should be advised this is not a \textit{usual} game (\ie{} nobody wins, nobody loses) and you can \textit{only} experiment with new strategic position of cells to invent something new or discover how the \textit{game} behaves $\ldots$ download a \cite{Windows_Executable} or a \cite{Java_Source} compatible with all operating system with \cite{Java_Wikipedia} installed.

\section{Sprouts}
\label{sec:Sprouts}
This is a very interesting \href{https://en.wikipedia.org/wiki/Paper-and-pencil_game}{paper-and-pencil} game and easy to play. Starting with a few dots and a sheet of paper, the two players start by drawing lines between two dots (you can end a line in the same spot you started it) and adding a new dot somewhere in the line just created; there are only few extra rules:
\begin{itemize}
\item any line cannot touch or cross itself or any other line
\item the new dot cannot be placed on top of one of the endpoints of the new line
\item no spot may have more than three lines attached to it
\end{itemize}

\begin{figure}[ht!]
\centering
\includegraphics[width=90mm]{ch/game-theory/img/sprouts.png}
\caption{An example of game of Sprouts}
\end{figure}

There are some simple mathematical facts that are worth noting.
\begin{enumerate}
\item one might argue that you can keep \textit{sprouting} forever, yet there is a maximum number of moves: $3n-1$ moves starting with $n$ dots.
\item another limit is the minimum number of moves, and even the fastest player cannot go below this limit: $2n$ moves starting with $n$ dots.
\item since no draws are possible there must be a perfect strategy (\ie{} optimal play) for either the first or the second player, starting with any number of dots. In 2007 a computer program was developed to find out who was the winner for all the games with up to $44$ spots. The status of the games with $45, 48, 49, 50, 51, 52, 54, 55, 56 \ldots$ spots are still unknown, but if you wish to draw less than 45 spots and win, keep in mind that \cite{David_Applegate_Wikipedia}, \cite{Jacobson} and \cite{Daniel_Sleator_Wikipedia} observed a pattern in their results, and conjectured that the first player has a winning strategy when
$$\text{number of starting spots} \equiv 3,4,5 \mod 6$$
\end{enumerate}

\section{On game winners}
\label{sec:On game winners}
If a game ends after finite number of moves, does it mean that at least one of the players has winning strategy?\\
\begin{solution}
We know from \cite{Kxc5X91Nig_Lemma_Wikipedia} that this is only possible if the tree representing all possible runs of the game is not finitely branching. In game theoretic terms, we must have positions in which there are infinitely many legal moves.\\
Call a node \textit{bad} if the sub-game starting from that node is undetermined. It is easy to see that a node is determined if all its immediate successors are determined, in other words, a bad node must have at least one bad successor. It follows that, if the initial node is undetermined, there is an endless play. Contra-positively, if no unending play is possible, the game is determined.\\
An interesting example of such a game is transfinite \cite{Nim_Wikipedia}. The number of piles is finite, and each pile is a well-ordered set, not necessarily finite; \ie{}., a position is described by a finite sequence of ordinal numbers. A move consists of removing a nonempty final segment from one pile, \ie{}., diminishing one of the ordinals. The game is determined, and its analysis is a straightforward generalization of the analysis of ordinary Nim, using the representation of an ordinal number in the binary form $2^{\alpha_1}+2^{\alpha_2}+\ldots +2^{\alpha_n}$ where $\alpha_1 > \alpha_2 > \ldots > \alpha_n$.\\
By the way, the games you are asking about can be turned into games of length $\omega$ by making the players keep on making irrelevant moves after the real game is over. That is, we're talking about the subclass of games of length $\omega$ consisting of games in which every possible play is decided after a finite (but unbounded) number of moves. Topologically speaking, these are the "clopen games".
\end{solution}

\section{Silent duels}
\label{silent-duels}
Newton and Leibniz both know that the closer they get to their target, the higher the chance of a successful shot. Eventually they’ll be standing nose-to-nose: a guaranteed hit! But the longer each waits, the more opportunity they give their opponent to fire. If they both fire and miss, mild embarrassment ensues and they resolve to try again tomorrow. When should they shoot to maximize their chance at victory?\\
This is the so-called silent duel problem, and as you might have guessed it can be phrased without any violence.\\
Two players compete to succeed in taking some action in the interval $[0,1]$. They are given a function $P(t)$ that describes the probability of success if the action is taken at time $t$. Since the two men are \textit{running} at each other, $P(t)$ is assumed to be increasing, with $P(0) = 0, P(1) = 1$. If Player 1 succeeds in their action first, Player 1 gets a dollar (1 unit of utility) from Player 2; if Player 2 succeeds, Player 1 loses a dollar to Player 2. What strategy should they use to maximize their expected payoff?

\section{Penney's game}
\label{sec:penney-game}
It's a binary (head/tail) sequence generating game between two players.
\begin{enumerate}
	\item A selects a sequence of heads and tails (of length 3 or larger), and shows this sequence to B
	\item B selects another sequence of heads and tails of the same length
	\item a fair coin is tossed until either A's or B's sequence appears as a consecutive subsequence of the coin toss outcomes
	\item The player whose sequence appears first wins
\end{enumerate}
Provided that the length of the sequences $\ge 3$, B has an edge over A. This is because the game is non-transitive such that for any given sequence of length three or longer one can find another sequence that has higher probability of occurring first.
$$
\begin{array}{c|c|c}
\text{A choice} & \text{B choice} & \text{odds in favour of B} \\
\hline
\text{HHH} & \text{THH} & \text{7 to 1}\\
\text{HHT} & \text{THH} & \text{3 to 1}\\
\text{HTH} & \text{HHT} & \text{2 to 1}\\
\text{HTT} & \text{HHT} & \text{2 to 1}\\
\text{THH} & \text{TTH} & \text{2 to 1}\\
\text{THT} & \text{TTH} & \text{2 to 1}\\
\text{TTH} & \text{HTT} & \text{3 to 1}\\
\text{TTT} & \text{HTT} & \text{7 to 1}\\
\end{array}
$$
